## CONTENTS OF THIS FILE

- Introduction
- Requirements
- Installation
- Configuration
- Operation
- Upgrading
- Maintainers


## INTRODUCTION

The Webform As Node module provides a matching Node for each webform.

The primary use case for this module is to provide easy addition
of fields to a Webform and to provide Views Entity Reference support. 
The Webform As Node content type can be managed like any Drupal
content type including the addition of fields that can be 
referenced using views in conjunction with the webform and
the webform submissions. 


## REQUIREMENTS

This module requires the Webform module.


## INSTALLATION

The installation of this module is like other Drupal modules.

1. If your site is [managed via Composer](https://www.drupal.org/node/2718229),
   use Composer to download the webform module running
   ```composer require "drupal/webform_as_node"```. Otherwise copy/upload the webform
   module to the modules directory of your Drupal installation.

2. The installation creates the matching Webform as Node nodes.
   Uninstalling the module will remove these nodes but not the matching webforms.


## CONFIGURATION

- The module requires no configuration. The default configuration
  for the content type Webform As Node is just the title. You can
  add and modify fields as with any node content.
- Webform selection for Webform field:
- Webform Views support

## OPERATION

The module was designed to minimize the interaction between the 
webform and matching node. The node is of type Webform As Node. 
The special thing about the node is the linkage to the webform. 

The module creates a webform_as_node table that has the cross reference
between a webform and a matching Webform As Node node. 

The module tracks create, update and delete operations. Deleting
either a webform or node removes the matching item. Same for
creating a new webform or node. 


## Editing Webform As Node

The node can be edited as usual and will show up in the normal
content list. The title field of the webform and node are synced
so changing one will be reflected in the other object. 

The node edit form is also shown in a new Webform settings tab
for the matching webform. 


## Webform as Node and Views Entity Reference Displays

There is a new Webform as Node entity type. This is essentially
the cross reference table and has links between the webform and
webform submissions and the Webform As Node nodes. The 
Webform As Node entity will be found in the list of items
when creating a view. While this entity has the same name as the
Webform As Node node they are distinct.  

The Webform As Node view can include an entity reference display.
These views can be used with the Webform Node field that lets
you select a matching webform. There is a new selection item
to complement the default entity reference view selection which
cannot really provide a webform for the field. 

The new selection option will be found when editing the Webform field
in the Referenc Type section. Select the:

   Views: Filter by Webform as Node view

The Views used to select the entities will list any Webform as Node
views with an Entity Reference view. 


## Webform As Node node and Views

The Webform As Node entity and the Webform As Node node can be
related in a view. Both the entity and node have support for 
fields, sorting and filters. 


## UPGRADING

- There are no upgrades at this time. 

## MAINTAINERS

Current maintainers for Drupal Webform as Node:

- Bill Wong (bwong) - https://www.drupal.org/u/bwong

