<?php

namespace Drupal\webform_as_node\Form;

use Drupal\node\NodeForm;
use Drupal\Core\Database\Database;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;

class WebformAsNodeEditForm extends NodeForm {
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'webform_as_node_edit_form';
  }

  /**
   * {@inheritdoc}
   */
  public function getBaseFormId() {
    return 'webform_as_node_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state, $webform = NULL) {
    $this->operation = 'edit';
//    $this->options['webform_id'] = $webform;
    $this->setModuleHandler(\Drupal::moduleHandler());
    $this->entityTypeManager = \Drupal::entityTypeManager();

    // Call the parent buildForm to ensure base functionality.
    $conn = Database::getConnection();
    $rows = $conn->select('webform_as_node')
      ->fields('webform_as_node',['nid'])
      ->condition('webform_id',$webform)
      ->execute()
      ->fetchAll();
    foreach ($rows as $row) {
      $nid = $row->nid;
    }
    $form_state->setValue('nid', $nid);
    $form_state->set('nid', $nid);

    $this->entity = $this->entityTypeManager->getStorage('node')->load($nid);

    $form = parent::buildForm($form, $form_state);

    // Eliminate extra buttons.
    unset($form['actions']['preview']);
    unset($form['actions']['delete']);

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    // Change redirect.
    (new RedirectResponse('/admin/structure/webform/manage/contact/settings/webform_as_node'))->send();
  }
}
