<?php

/**
 * @file
 * Views integration for the webform_as_node module.
 */

/**
 * Implements hook_views_data().
 */
function webform_as_node_views_data() {
  $data['webform_as_node'] = [
    'table' => [
      'entity type' => 'webform_as_node',
      'entity revision' => FALSE,
      'group' => t('Webform as Node'),
      'provider' => 'webform_as_node',
      'base' => [
        'field' => 'webform_id',
        'title' => 'Webform as Node',
      ],
      'join' => [
        'node_field_data' => [
          'left_field' => 'nid',
          'field' => 'nid',
        ],
      ],
    ],
    'nid' => [
      'title' => 'ID',
      'help' => t('Webform as Node nid'),
      'field' => [ 'id' => 'standard' ],
      'sort' => [ 'id' => 'standard' ],
      'filter' => [ 'id' => 'string' ],
      'argument' => [ 'id' => 'string' ],
      'relationship' => [
        'base' => 'node_field_data',
        'base field' => 'nid',
        'id' => 'standard',
        'label' => 'Webform as Node',
      ],
      'entity field' => 'nid',
    ],
    'webform_id' => [
      'title' => 'Webform ID',
      'help' => t('Machine name: webform_id'),
      'field' => [ 'id' => 'standard' ],
      'sort' => [ 'id' => 'standard' ],
      'filter' => [ 'id' => 'string' ],
      'argument' => [ 'id' => 'string' ],
      'relationship' => [
        'base' => 'webform_submission',
        'base field' => 'webform_id',
        'field' => 'webform_id',
        'id' => 'standard',
        'label' => 'Webform',
      ],
    ],
  ];

  return $data;
}

/**
 * Implements hook_views_data_alter().
 */
function webform_as_node_views_data_alter(array &$data) {
/* 
  // This will allow fields like 'title' to be added but
  // the node id used is null. Seems to work for filters but not fields.
  $data['node_field_data']['table']['join']['webform_as_node'] = [
    'left_field' => 'nid',
    'field' => 'nid',
  ];
*/

  $data['node_field_data']['webform_as_node'] = [
    'title' => t('Webform'),
    'help' => t('Webform via Webform as Node'),
    'relationship' => [
      'base' => 'webform_as_node',
      'base field' => 'nid',
      'field' => 'nid',
      'id' => 'standard',
      'label' => 'Webform',
      ],
    'entity field' => 'nid',
  ];

  $data['webform_submission']['webform'] = [
    'title' => t('Webform'),
    'help' => t('Webform via webform submission'),
    'relationship' => [
      'base' => 'webform_as_node',
      'base field' => 'webform_id',
      'field' => 'webform_id',
      'id' => 'standard',
      'label' => 'Webform',
      ],
    'entity field' => 'webform_id',
  ];
}

